<script setup lang="ts">

import CertificatesSelectView from '@/components/CertificatesListView.vue';
import BusyDisplay from '@/components/ProcessignView.vue';
import {nextTick, onMounted, Ref, ref, watch} from 'vue';
import ErrorView from '@/components/ErrorView.vue';
import {ESignSoftware, ESignStrategy, type TCertificateIdentifier, type TSignContext} from '@/types';
import {TCertificatesMap} from '@/provider/BrowserPlugin';

export enum ECertificateSignWidgetEvent {
  // todo эмитить обновление экрана
  FAILED = 'FAILED',
  SIGNED = 'SIGNED',
}

const emit = defineEmits<{
  // fixme: посмотреть, вероятно тут надо использовать контекст (посмотреть как работает match из rust с результатами)
  (e: ECertificateSignWidgetEvent.FAILED, error: Error): void,
  (e: ECertificateSignWidgetEvent.SIGNED, signature: string): void,
}>();

export type TStatus = 'idle' | 'processing' | 'certificate_select' | 'signed' | 'error' | 'done';

const status = ref<TStatus>('idle');

const handleCertificateSelected = (thumb: string) => {
  console.log('cert selected -> ', thumb);
}
</script>

<template>
  <div id="edsWrapper">
    <BusyDisplay v-if="status === 'processing'"/>
    <ErrorView v-if="status === 'error'"/>
    <CertificatesSelectView v-if="status === 'certificate_select'" @confirm-selection="handleCertificateSelected"/>
  </div>
</template>